regina::LayeredTorusBundle Class Reference
Standard Triangulations and Subcomplexes

Describes a layered torus bundle. More...

`#include <subcomplex/layeredtorusbundle.h>`

Inheritance diagram for regina::LayeredTorusBundle:

## Public Member Functions

virtual | ~LayeredTorusBundle ()
| Destroys this layered torus bundle and all of its internal components. More...
const TxICore & | core () const
| Returns the `T x I` triangulation at the core of this layered surface bundle. More...
const Isomorphism< 3 > * | coreIso () const
| Returns the isomorphism describing how the core `T x I` appears as a subcomplex of this layered surface bundle. More...
const Matrix2 & | layeringReln () const
| Returns a 2-by-2 matrix describing how the layering of tetrahedra relates curves on the two torus boundaries of the core `T x I`. More...
Manifold * | manifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
AbelianGroup * | homology () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes a detailed text representation of this object to the given output stream. More...
std::string | name () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | TeXName () const
| Returns the name of this specific triangulation in TeX format. More...
AbelianGroup * | homologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...

## Static Public Member Functions

static LayeredTorusBundle * | isLayeredTorusBundle (Triangulation< 3 > *tri)
| Determines if the given triangulation is a layered surface bundle. More...
static StandardTriangulation * | isStandardTriangulation (Component< 3 > *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static StandardTriangulation * | isStandardTriangulation (Triangulation< 3 > *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Detailed Description

Describes a layered torus bundle.

This is a triangulation of a torus bundle over the circle formed as follows.

We begin with a thin I-bundle over the torus, i.e,. a triangulation of the product `T x I` that is only one tetrahedron thick. This is referred to as the core, and is described by an object of type TxICore.

We then identify the upper and lower torus boundaries of this core according to some homeomorphism of the torus. This may be impossible due to incompatible boundary edges, and so we allow a layering of tetrahedra over one of the boundari tori in order to adjust the boundary edges accordingly. Layerings are described in more detail in the Layering class.

Given the parameters of the core `T x I` and the specific layering, the monodromy for this torus bundle over the circle can be calculated. The manifold() routine returns details of the corresponding 3-manifold.

All optional StandardTriangulation routines are implemented for this class.

## Constructor & Destructor Documentation

## ~LayeredTorusBundle()

virtual regina::LayeredTorusBundle::~LayeredTorusBundle | ( |  | ) |

virtual

Destroys this layered torus bundle and all of its internal components.

## Member Function Documentation

## core()

const TxICore & regina::LayeredTorusBundle::core | ( |  | ) | const

inline

Returns the `T x I` triangulation at the core of this layered surface bundle.

This is the product `T x I` whose boundaries are joined (possibly via some layering of tetrahedra).

Note that the triangulation returned by TxICore::core() (that is, LayeredTorusBundle::core().core()) may well use different tetrahedron and vertex numbers. That is, an isomorphic copy of it appears within this layered surface bundle but the individual tetrahedra and vertices may have been permuted. For a precise mapping from the TxICore::core() triangulation to this triangulation, see the routine coreIso().

Returns
  the core `T x I` triangulation.

## coreIso()

const Isomorphism< 3 > * regina::LayeredTorusBundle::coreIso | ( |  | ) | const

inline

Returns the isomorphism describing how the core `T x I` appears as a subcomplex of this layered surface bundle.

As described in the core() notes, the core `T x I` triangulation returned by TxICore::core() appears within this layered surface bundle, but not necessarily with the same tetrahedron or vertex numbers.

This routine returns an isomorphism that maps the tetrahedra and vertices of the core `T x I` triangulation (as returned by LayeredTorusBundle::core().core()) to the tetrahedra and vertices of this overall layered surface bundle.

The isomorphism that is returned belongs to this object, and should not be modified or destroyed.

Returns
  the isomorphism from the core `T x I` to this layered surface bundle.

## detail()

std::string regina::Output< StandardTriangulation , false >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## homology()

AbelianGroup* regina::LayeredTorusBundle::homology | ( |  | ) | const

virtual

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling Triangulation<3>::homology() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this StandardTriangulation describes an entire Triangulation<3> (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling Triangulation<3>::homology() upon the associated real triangulation.

This routine can also be accessed via the alias homologyH1() (a name that is more specific, but a little longer to type).

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::StandardTriangulation.

## homologyH1()

AbelianGroup * regina::StandardTriangulation::homologyH1 | ( |  | ) | const

inline inherited

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling Triangulation<3>::homology() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this StandardTriangulation describes an entire Triangulation<3> (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling Triangulation<3>::homology() upon the associated real triangulation.

This routine can also be accessed via the alias homology() (a name that is less specific, but a little easier to type).

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

## isLayeredTorusBundle()

static LayeredTorusBundle* regina::LayeredTorusBundle::isLayeredTorusBundle | ( | Triangulation< 3 > * | tri | ) |

static

Determines if the given triangulation is a layered surface bundle.

Parameters

  tri | the triangulation to examine.

Returns
  a newly created structure containing details of the layered surface bundle, or `null` if the given triangulation is not a layered surface bundle.

## isStandardTriangulation() [1/2]

static StandardTriangulation* regina::StandardTriangulation::isStandardTriangulation | ( | Component< 3 > * | component | ) |

static inherited

Determines whether the given component represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given component must have the same corresponding boundary triangles, i.e., the component cannot have any further identifications of these boundary triangles with each other.

Note that the triangulation-based routine isStandardTriangulation(Triangulation<3>*) may recognise more triangulations than this routine, since passing an entire triangulation allows access to more information.

Parameters

  component | the triangulation component under examination.

Returns
  the details of the standard triangulation if the given component is recognised, or 0 otherwise.

## isStandardTriangulation() [2/2]

static StandardTriangulation* regina::StandardTriangulation::isStandardTriangulation | ( | Triangulation< 3 > * | tri | ) |

static inherited

Determines whether the given triangulation represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given triangulation must have the same corresponding boundary triangles, i.e., the triangulation cannot have any further identifications of these boundary triangles with each other.

This routine may recognise more triangulations than the component-based isStandardTriangulation(Component<3>*), since passing an entire triangulation allows access to more information.

Parameters

  tri | the triangulation under examination.

Returns
  the details of the standard triangualation if the given triangulation is recognised, or 0 otherwise.

## layeringReln()

const Matrix2 & regina::LayeredTorusBundle::layeringReln | ( |  | ) | const

inline

Returns a 2-by-2 matrix describing how the layering of tetrahedra relates curves on the two torus boundaries of the core `T x I`.

The TxICore class documentation describes generating alpha and beta curves on the two torus boundaries of the core `T x I` (which are referred to as the upper and lower boundaries). The two boundary tori are parallel in two directions: through the core, and through the layering. It is desirable to know the parallel relationship between the two sets of boundary curves in each direction.

The relationship through the core is already described by TxICore::parallelReln(). This routine describes the relationship through the layering.

Let a_u and b_u be the alpha and beta curves on the upper boundary torus, and let a_l and b_l be the alpha and beta curves on the lower boundary torus. Suppose that the upper alpha is parallel to w.a_l + x.b_l, and that the upper beta is parallel to y.a_l + z.b_l. Then the matrix returned will be

        [ w  x ]
        [      ] .
        [ y  z ]

In other words,

        [ a_u ]                      [ a_l ]
        [     ]  =  layeringReln() * [     ] .
        [ b_u ]                      [ b_l ]

It can be observed that this matrix expresses the upper boundary curves in terms of the lower, whereas TxICore::parallelReln() expresses the lower boundary curves in terms of the upper. This means that the monodromy describing the overall torus bundle over the circle can be calculated as

        M  =  layeringReln() * core().parallelReln()

or alternatively using the similar matrix

        M'  =  core().parallelReln() * layeringReln() .

Note that in the degenerate case where there is no layering at all, this matrix is still perfectly well defined; in this case it describes a direct identification between the upper and lower boundary tori.

Returns
  the relationship through the layering between the upper and lower boundary curves of the core `T x I`.

## manifold()

Manifold* regina::LayeredTorusBundle::manifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::StandardTriangulation.

## name()

std::string regina::StandardTriangulation::name | ( |  | ) | const

inherited

Returns the name of this specific triangulation as a human-readable string.

Returns
  the name of this triangulation.

## str()

std::string regina::Output< StandardTriangulation , false >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:
  In addition to str(), this is also used as the Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## TeXName()

std::string regina::StandardTriangulation::TeXName | ( |  | ) | const

inherited

Returns the name of this specific triangulation in TeX format.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Returns
  the name of this triangulation in TeX format.

## utf8()

std::string regina::Output< StandardTriangulation , false >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

## writeName()

std::ostream & regina::LayeredTorusBundle::writeName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::StandardTriangulation.

## writeTeXName()

std::ostream & regina::LayeredTorusBundle::writeTeXName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::StandardTriangulation.

## writeTextLong()

void regina::LayeredTorusBundle::writeTextLong | ( | std::ostream & | out | ) | const

virtual

Writes a detailed text representation of this object to the given output stream.

This may be reimplemented by subclasses, but the parent StandardTriangulation class offers a reasonable default implementation based on writeName().

Python:
  Not present.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::StandardTriangulation.

## writeTextShort()

void regina::StandardTriangulation::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes a short text representation of this object to the given output stream.

This may be reimplemented by subclasses, but the parent StandardTriangulation class offers a reasonable default implementation based on writeName().

Python:
  Not present.

Parameters

  out | the output stream to which to write.

The documentation for this class was generated from the following file:

- subcomplex/layeredtorusbundle.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).